/* Generated by re2c 0.12.3 on Sat Aug 15 14:16:56 2009 */
#line 1 "./hallexer.re"
/*
 * hallexer.re
 *
 * Created: 6/23-2007
 * Last update: 6/23-2007
 *
 *******************************************************************/
/************************************************************************
 *
 *   Emdros - the database engine for analyzed or annotated text
 *   Copyright (C) 2001-2007  Ulrik Petersen
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, license version 2.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *   Other licensing forms
 *   =====================
 *
 *   If you wish to negotiate commercial licensing, please contact
 *   Ulrik Petersen at ulrikp[at]users.sourceforge.net.
 *
 *   Licensing can also be negotiated if your organization is an
 *   educational, non-profit, charity, missionary or similar
 *   organization.
 *
 **************************************************************************/


#define HAL_LEXER


#include <string>
#include <sstream>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include "hal_execution_environment.h"
#include "hal_defines.h"
#include "hallexer.h"

#define BSIZE 8192

#define YYCTYPE         unsigned char
#define YYCURSOR        cur
#define YYLIMIT         lim
#define YYMARKER        ptr
#define YYFILL(n)       {cur = fill(cur);}

#line 63 "./hallexer.re"


HALScanner::HALScanner(std::istream *pIstr)
{
	pIn = pIstr;
	bot = tok = ptr = cur = pos = lim = top = eof = 0;
}

HALScanner::~HALScanner()
{
	if (bot) {
		delete[] bot;
	}
}

void HALScanner::addWord(void)
{
	std::string result;
	const char *p;
	for (p = tok;
	     p != cur;
	     ++p) {
	     result.append(1, *p);
	}
	pHEE->set_current_word(result);
}

char *HALScanner::fill(char *cursor)
{
        if(!eof)
        {
                unsigned int cnt = tok - bot;
                if(cnt)
                {
                        memcpy(bot, tok, lim - tok);
                        tok = bot;
                        ptr -= cnt;
                        cursor -= cnt;
                        pos -= cnt;
                        lim -= cnt;
                }
                if((top - lim) < BSIZE)
                {
                        char *buf = new char[(lim - bot) + BSIZE];
                        memcpy(buf, tok, lim - tok);
                        tok = buf;
                        ptr = &buf[ptr - bot];
                        cursor = &buf[cursor - bot];
                        pos = &buf[pos - bot];
                        lim = &buf[lim - bot];
                        top = &lim[BSIZE];
                        delete [] bot;
                        bot = buf;
                }
                pIn->read(lim, BSIZE);
                if ((cnt = pIn->gcount()) != BSIZE )
                {
                        eof = &lim[cnt]; *eof++ = '\0';
                }
                lim += cnt;
        }
        return cursor;
}


int HALScanner::scan(HAL_Execution_environment *pHee)
{
	pHEE = pHee;
	

 scan:	
	tok = cur;


#line 138 "hallexer.cpp"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;

	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= '^') {
		if(yych <= '-') {
			if(yych <= ' ') {
				if(yych <= 0x08) {
					if(yych <= 0x00) goto yy20;
					goto yy22;
				} else {
					if(yych <= 0x0A) goto yy16;
					if(yych <= 0x1F) goto yy22;
					goto yy16;
				}
			} else {
				if(yych <= '&') {
					if(yych <= '!') goto yy10;
					if(yych >= '#') goto yy14;
				} else {
					if(yych <= '(') goto yy2;
					if(yych <= ',') goto yy14;
					goto yy8;
				}
			}
		} else {
			if(yych <= '?') {
				if(yych <= '9') {
					if(yych <= '.') goto yy10;
					if(yych <= '/') goto yy14;
					goto yy12;
				} else {
					if(yych <= ';') goto yy14;
					if(yych <= '>') goto yy22;
					goto yy10;
				}
			} else {
				if(yych <= '[') {
					if(yych <= '@') goto yy22;
					if(yych <= 'Z') goto yy4;
					goto yy14;
				} else {
					if(yych == ']') goto yy14;
					goto yy22;
				}
			}
		}
	} else {
		if(yych <= 0xB4) {
			if(yych <= 0x7F) {
				if(yych <= 'z') {
					if(yych <= '_') goto yy14;
					if(yych <= '`') goto yy22;
					goto yy4;
				} else {
					if(yych == '~') goto yy14;
					goto yy22;
				}
			} else {
				if(yych <= 0xA7) {
					if(yych <= 0xA5) goto yy18;
					if(yych <= 0xA6) goto yy6;
					goto yy14;
				} else {
					if(yych <= 0xA8) goto yy4;
					if(yych <= 0xB3) goto yy18;
					goto yy4;
				}
			}
		} else {
			if(yych <= 0xC1) {
				if(yych <= 0xBB) {
					if(yych == 0xB8) goto yy4;
					goto yy18;
				} else {
					if(yych == 0xBF) goto yy18;
					goto yy4;
				}
			} else {
				if(yych <= 0xD7) {
					if(yych <= 0xC2) goto yy7;
					if(yych <= 0xD6) goto yy4;
					goto yy18;
				} else {
					if(yych == 0xF7) goto yy18;
					goto yy4;
				}
			}
		}
	}
yy2:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '}') {
		if(yych <= '/') {
			if(yych <= '&') {
				if(yych == '"') goto yy30;
			} else {
				if(yych <= ')') goto yy30;
				if(yych == '-') goto yy32;
			}
		} else {
			if(yych <= '[') {
				if(yych <= '9') goto yy37;
				if(yych <= '@') goto yy3;
				if(yych <= 'Z') goto yy35;
				goto yy37;
			} else {
				if(yych <= '`') goto yy3;
				if(yych <= 'z') goto yy35;
				if(yych >= '}') goto yy37;
			}
		}
	} else {
		if(yych <= 0xB8) {
			if(yych <= 0xA8) {
				if(yych == 0xA6) goto yy35;
				if(yych >= 0xA8) goto yy35;
			} else {
				if(yych == 0xB4) goto yy35;
				if(yych >= 0xB8) goto yy35;
			}
		} else {
			if(yych <= 0xD6) {
				if(yych <= 0xBB) goto yy3;
				if(yych != 0xBF) goto yy35;
			} else {
				if(yych <= 0xD7) goto yy3;
				if(yych != 0xF7) goto yy35;
			}
		}
	}
yy3:
#line 137 "./hallexer.re"
	{ goto scan; }
#line 275 "hallexer.cpp"
yy4:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 0xA6) {
		if(yych <= 'Z') {
			if(yych <= '/') {
				if(yych == '-') goto yy32;
				goto yy31;
			} else {
				if(yych <= '9') goto yy37;
				if(yych <= '@') goto yy31;
				goto yy35;
			}
		} else {
			if(yych <= 'z') {
				if(yych <= '[') goto yy37;
				if(yych <= '`') goto yy31;
				goto yy35;
			} else {
				if(yych == '}') goto yy37;
				if(yych <= 0xA5) goto yy31;
				goto yy35;
			}
		}
	} else {
		if(yych <= 0xBB) {
			if(yych <= 0xB3) {
				if(yych == 0xA8) goto yy35;
				goto yy31;
			} else {
				if(yych <= 0xB4) goto yy35;
				if(yych == 0xB8) goto yy35;
				goto yy31;
			}
		} else {
			if(yych <= 0xD6) {
				if(yych == 0xBF) goto yy31;
				goto yy35;
			} else {
				if(yych <= 0xD7) goto yy31;
				if(yych == 0xF7) goto yy31;
				goto yy35;
			}
		}
	}
yy5:
#line 139 "./hallexer.re"
	{ addWord(); return TT_WORD; }
#line 323 "hallexer.cpp"
yy6:
	yych = *++YYCURSOR;
	if(yych <= 0xA6) {
		if(yych <= 'Z') {
			if(yych <= '/') {
				if(yych == '-') goto yy32;
				goto yy31;
			} else {
				if(yych <= '9') goto yy37;
				if(yych <= '@') goto yy31;
				goto yy35;
			}
		} else {
			if(yych <= 'z') {
				if(yych <= '[') goto yy37;
				if(yych <= '`') goto yy31;
				goto yy35;
			} else {
				if(yych == '}') goto yy37;
				if(yych <= 0xA5) goto yy31;
				goto yy35;
			}
		}
	} else {
		if(yych <= 0xBB) {
			if(yych <= 0xB3) {
				if(yych == 0xA8) goto yy35;
				goto yy31;
			} else {
				if(yych <= 0xB4) goto yy35;
				if(yych == 0xB8) goto yy35;
				goto yy31;
			}
		} else {
			if(yych <= 0xD6) {
				if(yych == 0xBF) goto yy31;
				goto yy35;
			} else {
				if(yych <= 0xD7) goto yy31;
				if(yych == 0xF7) goto yy31;
				goto yy35;
			}
		}
	}
yy7:
	yych = *++YYCURSOR;
	if(yych <= 0xA6) {
		if(yych <= 'Z') {
			if(yych <= '/') {
				if(yych == '-') goto yy32;
				goto yy31;
			} else {
				if(yych <= '9') goto yy37;
				if(yych <= '@') goto yy31;
				goto yy35;
			}
		} else {
			if(yych <= 'z') {
				if(yych <= '[') goto yy37;
				if(yych <= '`') goto yy31;
				goto yy35;
			} else {
				if(yych == '}') goto yy37;
				if(yych <= 0xA5) goto yy31;
				goto yy35;
			}
		}
	} else {
		if(yych <= 0xBB) {
			if(yych <= 0xB3) {
				if(yych == 0xA8) goto yy35;
				goto yy31;
			} else {
				if(yych <= 0xB4) goto yy35;
				if(yych == 0xB8) goto yy35;
				goto yy31;
			}
		} else {
			if(yych <= 0xD6) {
				if(yych == 0xBF) goto yy31;
				goto yy35;
			} else {
				if(yych <= 0xD7) goto yy31;
				if(yych == 0xF7) goto yy31;
				goto yy35;
			}
		}
	}
yy8:
	++YYCURSOR;
#line 140 "./hallexer.re"
	{ goto scan; }
#line 416 "hallexer.cpp"
yy10:
	++YYCURSOR;
#line 141 "./hallexer.re"
	{ std::string punct;
			  punct.append(1, *cur);
			  pHEE->set_current_punctuation(punct); 
			  return TT_END_OF_SENTENCE_PUNCTUATION; 
			}
#line 425 "hallexer.cpp"
yy12:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '-') {
		if(yych == ',') goto yy24;
	} else {
		if(yych <= '.') goto yy24;
		if(yych <= '/') goto yy13;
		if(yych <= '9') goto yy27;
	}
yy13:
#line 146 "./hallexer.re"
	{ addWord(); return TT_NUMBER; }
#line 439 "hallexer.cpp"
yy14:
	++YYCURSOR;
#line 150 "./hallexer.re"
	{ goto scan; }
#line 444 "hallexer.cpp"
yy16:
	++YYCURSOR;
#line 151 "./hallexer.re"
	{ goto scan; }
#line 449 "hallexer.cpp"
yy18:
	++YYCURSOR;
#line 152 "./hallexer.re"
	{ goto scan; }
#line 454 "hallexer.cpp"
yy20:
	++YYCURSOR;
#line 153 "./hallexer.re"
	{ if (cur == eof) { goto end; } }
#line 459 "hallexer.cpp"
yy22:
	++YYCURSOR;
#line 154 "./hallexer.re"
	{ goto scan; }
#line 464 "hallexer.cpp"
yy24:
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '-') {
		if(yych == ',') goto yy24;
	} else {
		if(yych <= '.') goto yy24;
		if(yych <= '/') goto yy26;
		if(yych <= '9') goto yy27;
	}
yy26:
	YYCURSOR = YYMARKER;
	if(yyaccept <= 0) {
		goto yy13;
	} else {
		goto yy29;
	}
yy27:
	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '-') {
		if(yych == ',') goto yy24;
	} else {
		if(yych <= '.') goto yy24;
		if(yych <= '/') goto yy29;
		if(yych <= '9') goto yy27;
	}
yy29:
#line 147 "./hallexer.re"
	{ /* NOTE: When changing this definition, 
                                 also change HAL_Execution_environment::is_number(). */
                                  addWord(); return TT_NUMBER; }
#line 500 "hallexer.cpp"
yy30:
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy31:
	if(yych <= 0xA7) {
		if(yych <= '-') {
			if(yych <= '&') {
				if(yych == '"') goto yy30;
				goto yy5;
			} else {
				if(yych <= ')') goto yy30;
				if(yych <= ',') goto yy5;
				goto yy30;
			}
		} else {
			if(yych <= '`') {
				if(yych <= '@') goto yy5;
				if(yych <= 'Z') goto yy30;
				goto yy5;
			} else {
				if(yych <= 'z') goto yy30;
				if(yych == 0xA6) goto yy30;
				goto yy5;
			}
		}
	} else {
		if(yych <= 0xBB) {
			if(yych <= 0xB4) {
				if(yych <= 0xA8) goto yy30;
				if(yych <= 0xB3) goto yy5;
				goto yy30;
			} else {
				if(yych == 0xB8) goto yy30;
				goto yy5;
			}
		} else {
			if(yych <= 0xD6) {
				if(yych == 0xBF) goto yy5;
				goto yy30;
			} else {
				if(yych <= 0xD7) goto yy5;
				if(yych == 0xF7) goto yy5;
				goto yy30;
			}
		}
	}
yy32:
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= '|') {
		if(yych <= '-') {
			if(yych <= '\'') {
				if(yych == '"') goto yy40;
				if(yych >= '\'') goto yy40;
			} else {
				if(yych <= '(') goto yy30;
				if(yych <= ')') goto yy40;
				if(yych >= '-') goto yy32;
			}
		} else {
			if(yych <= 'Z') {
				if(yych <= '/') goto yy34;
				if(yych <= '9') goto yy37;
				if(yych >= 'A') goto yy35;
			} else {
				if(yych <= '[') goto yy37;
				if(yych <= '`') goto yy34;
				if(yych <= 'z') goto yy35;
			}
		}
	} else {
		if(yych <= 0xB7) {
			if(yych <= 0xA7) {
				if(yych <= '}') goto yy37;
				if(yych == 0xA6) goto yy35;
			} else {
				if(yych <= 0xA8) goto yy35;
				if(yych == 0xB4) goto yy35;
			}
		} else {
			if(yych <= 0xBF) {
				if(yych <= 0xB8) goto yy35;
				if(yych <= 0xBB) goto yy34;
				if(yych <= 0xBE) goto yy35;
			} else {
				if(yych <= 0xD7) {
					if(yych <= 0xD6) goto yy35;
				} else {
					if(yych != 0xF7) goto yy35;
				}
			}
		}
	}
yy34:
#line 138 "./hallexer.re"
	{ addWord(); return TT_WORD; }
#line 599 "hallexer.cpp"
yy35:
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '}') {
		if(yych <= '/') {
			if(yych <= '&') {
				if(yych == '"') goto yy30;
				goto yy5;
			} else {
				if(yych <= ')') goto yy30;
				if(yych == '-') goto yy32;
				goto yy5;
			}
		} else {
			if(yych <= '[') {
				if(yych <= '9') goto yy37;
				if(yych <= '@') goto yy5;
				if(yych <= 'Z') goto yy35;
			} else {
				if(yych <= '`') goto yy5;
				if(yych <= 'z') goto yy35;
				if(yych <= '|') goto yy5;
			}
		}
	} else {
		if(yych <= 0xB8) {
			if(yych <= 0xA8) {
				if(yych == 0xA6) goto yy35;
				if(yych <= 0xA7) goto yy5;
				goto yy35;
			} else {
				if(yych == 0xB4) goto yy35;
				if(yych <= 0xB7) goto yy5;
				goto yy35;
			}
		} else {
			if(yych <= 0xD6) {
				if(yych <= 0xBB) goto yy5;
				if(yych == 0xBF) goto yy5;
				goto yy35;
			} else {
				if(yych <= 0xD7) goto yy5;
				if(yych == 0xF7) goto yy5;
				goto yy35;
			}
		}
	}
yy37:
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= ',') {
		if(yych <= '&') {
			if(yych != '"') goto yy34;
		} else {
			if(yych == '(') goto yy34;
			if(yych >= '*') goto yy34;
		}
	} else {
		if(yych <= 'Z') {
			if(yych <= '-') goto yy37;
			if(yych <= '/') goto yy34;
			if(yych <= '9') goto yy37;
			goto yy34;
		} else {
			if(yych <= '[') goto yy37;
			if(yych == '}') goto yy37;
			goto yy34;
		}
	}
	yych = *++YYCURSOR;
	goto yy34;
yy40:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 0xA7) {
		if(yych <= '-') {
			if(yych <= '&') {
				if(yych == '"') goto yy30;
				goto yy34;
			} else {
				if(yych <= ')') goto yy30;
				if(yych <= ',') goto yy34;
				goto yy30;
			}
		} else {
			if(yych <= '`') {
				if(yych <= '@') goto yy34;
				if(yych <= 'Z') goto yy30;
				goto yy34;
			} else {
				if(yych <= 'z') goto yy30;
				if(yych == 0xA6) goto yy30;
				goto yy34;
			}
		}
	} else {
		if(yych <= 0xBB) {
			if(yych <= 0xB4) {
				if(yych <= 0xA8) goto yy30;
				if(yych <= 0xB3) goto yy34;
				goto yy30;
			} else {
				if(yych == 0xB8) goto yy30;
				goto yy34;
			}
		} else {
			if(yych <= 0xD6) {
				if(yych == 0xBF) goto yy34;
				goto yy30;
			} else {
				if(yych <= 0xD7) goto yy34;
				if(yych == 0xF7) goto yy34;
				goto yy30;
			}
		}
	}
}
#line 155 "./hallexer.re"


 end:
 	return 0;
}
